﻿Imports System.IO.Ports
Imports System.Threading

Module Module1

    Public WithEvents serial As New SerialPort()
    'Dim handler As New SerialDataReceivedEventHandler(AddressOf SerialDataReceivedEventHandler)

    Sub Main()
        Dim portName As String = String.Empty
        Dim baud As Integer
        Dim cki As ConsoleKeyInfo


        Console.WriteLine("We need to open a serial port!")
        Console.WriteLine("Enter a serial port name in the form of COM1")
        portName = Console.ReadLine()

        Console.WriteLine("Enter a baud rate. Integers only, 57600 is a good baud.")
        baud = Integer.Parse(Console.ReadLine())

        serial.PortName = portName
        serial.BaudRate = baud
        serial.Open()

        If serial.IsOpen() Then
            Console.WriteLine("Port {0} open at {1}", serial.PortName, serial.BaudRate)
            Console.WriteLine("Waiting for serial port DataReceived event.")

        End If

        Do
            cki = Console.ReadKey(True)
            Thread.Sleep(1)
        Loop While cki.Key <> ConsoleKey.Escape

        serial.Close()


    End Sub


    Public Sub SerialDataReceivedEventHandler(ByVal sender As Object, ByVal e As SerialDataReceivedEventArgs) Handles serial.DataReceived

        Dim readBuffer(serial.BytesToRead) As Byte

        Dim numBytes As Integer = serial.Read(readBuffer, 0, readBuffer.Length)


        Console.WriteLine(BitConverter.ToString(readBuffer))

        'For i As Integer = 0 To numBytes - 1
        '    Console.Write(readBuffer(i) & " ")
        'Next i

    End Sub

End Module
